package com.dxhy.erp.entity.sdny;

import com.alibaba.fastjson.JSONObject;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 用户信息
 *
 * @author guoker
 * @date 2020-12-28
 */
@Data
public class OrgUserInfo extends Page implements Serializable {

    /**
     * 主键ID
     */
    private String id;

    /**
     * 员工ID
     */
    private String userId;

    /**
     * 员工名称
     */
    private String userName;

    /**
     * 员工身份证号
     */
    private String identityNumber;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 更新时间
     */
    private Date updateTime;

    /**
     * 所属企业ID
     */
    private String enterpriseId;

    /**
     * 税号
     */
    private String taxNo;

    /**
     * 是否白名单 Y/N
     */
    private String isWhiteList;

    /**
     * 可报销企业代码
     */
    private String enterpriseCodeList;

    /**
     * 所属企业名称
     */
    private String enterpriseName;

    /**
     * 邮箱
     */
    private String email;

    /**
     * 是否为第一次授权:1 是  0否
     */
    private String authStatus;

    private Integer page;

    private Integer size;

    /**
     * 密码（微信公众号登陆）
     */
    private String password;

    /**
     * 手机号
     */
    private String phone;

    /**
     * 同步过来的唯一id，用来区分userId是否变化
     */
    private String syncOnlyId;

    /**
     * 可报销企业名称
     */
    private String enterpriseNameList;

    public OrgUserInfo(){

    }
    public OrgUserInfo(String userId, String enterpriseId, String isWhiteList){
        this.userId = userId;
        this.enterpriseId = enterpriseId;
        this.isWhiteList = isWhiteList;
    }
    public OrgUserInfo(String userId, String enterpriseId, String identityNumber, String isWhiteList){
        this.userId = userId;
        this.enterpriseId = enterpriseId;
        this.identityNumber = identityNumber;
        this.isWhiteList = isWhiteList;
    }
    public OrgUserInfo(Builder builder){
        this.id = builder.id;
        this.userName = builder.userName;
        this.identityNumber = builder.identityNumber;
        this.taxNo = builder.taxNo;
        this.enterpriseCodeList = builder.enterpriseCodeList;
        this.enterpriseName = builder.enterpriseName;
        this.isWhiteList = builder.isWhiteList;
        this.email = builder.email;
        this.phone = builder.phone;
        this.authStatus = builder.authStatus;
        this.userId = builder.userId;
        this.enterpriseId = builder.enterpriseId;

    }

    public OrgUserInfo(JSONObject dataJson){
        this.userId = String.valueOf(dataJson.get("userId"));
        this.userName = String.valueOf(dataJson.get("userName"));
        this.email = String.valueOf(dataJson.get("email"));
        this.phone = String.valueOf(dataJson.get("mobile"));
        this.isWhiteList = "Y";
        this.enterpriseId = String.valueOf(dataJson.get("enterpriseId"));

    }


    @Data
    public static class Builder{
        /**
         * 主键ID
         */
        private String id;

        /**
         * 员工ID
         */
        private String userId;

        /**
         * 员工名称
         */
        private String userName;

        /**
         * 员工身份证号
         */
        private String identityNumber;

        /**
         * 创建时间
         */
        private Date createTime;

        /**
         * 更新时间
         */
        private Date updateTime;

        /**
         * 企业ID
         */
        private String enterpriseId;

        /**
         * 税号
         */
        private String taxNo;

        /**
         * 是否白名单 Y/N
         */
        private String isWhiteList;

        /**
         * 可报销企业代码
         */
        private String enterpriseCodeList;

        /**
         * 可报销企业名称
         */
        private String enterpriseName;

        /**
         * 邮箱
         */
        private String email;

        /**
         * 是否为第一次授权:1 是  0否
         */
        private String authStatus;

        private Integer page;

        private Integer size;

        // 密码（微信公众号登陆）
        private String password;

        // 手机号
        private String phone;

        // 同步过来的唯一id，用来区分userId是否变化
        private String syncOnlyId;


        public Builder(String userId, String enterpriseId){
            this.userId = userId;
            this.enterpriseId = enterpriseId;
        }

        public OrgUserInfo builder(){
            return new OrgUserInfo(this);
        }
    }

}
