package com.dxhy.erp.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.dxhy.common.service.impl.MpBaseServiceImpl;
import com.dxhy.erp.dao.BaseTDxRecordInvoiceDao;
import com.dxhy.erp.entity.BaseTDxRecordInvoice;
import com.dxhy.erp.service.BaseIReceiptInvoiceService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Author wangzhikun
 * @Date 2022/12/24 2022/12/24
 */

/**
 * @author peipei.li
 * @date 2019-04-23 进项税模块，底账表单表相关操作
 */
@SuppressWarnings("AlibabaUndefineMagicConstant")
@Service("baseIReceiptInvoiceService")
public class BaseIReceiptInvoiceServiceImpl extends MpBaseServiceImpl<BaseTDxRecordInvoiceDao, BaseTDxRecordInvoice> implements BaseIReceiptInvoiceService {
    @Override
    public List<BaseTDxRecordInvoice> selectByUuids(String[] uuids) {
        QueryWrapper<BaseTDxRecordInvoice> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().in(BaseTDxRecordInvoice::getUuid, uuids);
        return super.list(queryWrapper);
    }

    @Override
    public void updateBatch(List<BaseTDxRecordInvoice> condList) {
        for (BaseTDxRecordInvoice entity : condList) {
            LambdaUpdateWrapper<BaseTDxRecordInvoice> updateWrapper =
                    new UpdateWrapper<BaseTDxRecordInvoice>().lambda();
            updateWrapper.eq(BaseTDxRecordInvoice::getId, entity.getId());
            super.update(entity, updateWrapper);
        }
        super.succResult(new JSONObject());

    }
}
